# coding: utf-8




import math
import time
import kivy
from kivy.app import App
from kivy.lang import Builder
from kivy.uix.button import Button
from kivy.uix.floatlayout import FloatLayout
from kivy.uix.boxlayout import BoxLayout
from kivy.core.window import Window
from kivy.clock import Clock
from kivy.uix.slider import Slider
from kivy.properties import NumericProperty
from kivy.properties import ConfigParser, ObjectProperty, StringProperty ,BooleanProperty
from kivy.graphics import Color, Ellipse,Line,Rectangle,Triangle
from kivy.uix.label import Label
from kivy.uix.popup import Popup
from kivy.uix.checkbox import CheckBox

pose_ =[]
pose_ = 10 * [0]
roll_=0

ROLL = 0
PITCH = 0
YAW = 0
YAW_Line=[]
YAW_Line = 365 * [0]
YAW_Label =[]
YAW_Label = 10 * [0]
ROLL_Label=0
ROLL_Line =[]
ROLL_Line = 365 * [0]
PITCH_Line1 =[]
PITCH_Line1 = 365 * [0]
PITCH_Label1 =[]
PITCH_Label1 = 365 * [0]
PITCH_Line2 =[]
PITCH_Line2 = 365 * [0]
PITCH_Label2 =[]
PITCH_Label2 = 365 * [0]
ROLL_Label =[]
ROLL_Label = 365 * [0]
ROLL_Label_=0
RD_FLG = 0
class Send:

    def send_Pose(self,data_):
        global ROLL,PITCH,YAW,RD_FLG
	
	ROLL=-data_[3]
	PITCH=data_[4]
	YAW=data_[5]
	if RD_FLG==1:
		
		ROLL=math.degrees( -data_[3] )
		PITCH=math.degrees( data_[4] )
		YAW=math.degrees( data_[5] )
		
        return data_
class RootWidget(FloatLayout):
    Label_ROLL=0
    
    
    Con_Port_In_deg = BooleanProperty(False)
    Con_Port_In_rad = BooleanProperty(True)
    
    def __init__(self, **kwargs):
        super(RootWidget, self).__init__(**kwargs)
        Clock.schedule_interval(self.my_callback, 1/10)
        
                   
    def on_touch_down(self, touch):
        super(RootWidget, self).on_touch_down(touch)
	if touch.is_double_tap:
	        pass
        pass
        
    def on_touch_up(self, touch):
        super(RootWidget, self).on_touch_up(touch)
	pass
    
    def on_touch_move(self, touch):
        super(RootWidget, self).on_touch_move(touch)
        pass
        
    	
    def my_callback(self,dt):
        global pose_,ROLL,PITCH,YAW,YAW_Line,PITCH_Line,RD_FLG
        
        if self.Con_Port_In_rad == True:
	    RD_FLG=1
	elif self.Con_Port_In_deg== True:
	    RD_FLG=2
	
	
        HUD_R =1.0
        HUD_G =1.0
        HUD_B = 0.0
        HUD_R =0.2
        HUD_G =1.0
        HUD_B = 0.80
	RAD_ROLL = math.radians( ROLL )
	Roll_C= math.cos( RAD_ROLL )
	Roll_S= math.sin( RAD_ROLL )
	RAD_ROLL2 = math.radians( ROLL+180 )
	Roll_C2= math.cos( RAD_ROLL2 )
	Roll_S2= math.sin( RAD_ROLL2 )    
#####################################################################################	    
	#YAW
#####################################################################################
	Y_light_K =1.0
	Y_light_LK =1
        YAW_W =200
        YAW_H =400
	with self.canvas.after:
            self.canvas.after.clear()
            
	    Color( 1, 1, 0)
            ER_=5
	    Rotate_YAW=0
   	    for i in xrange(0, 36):
  	 	    if math.cos( math.radians(YAW+Rotate_YAW) ) >=-0.01 :
   	                K=math.cos( math.radians(YAW+Rotate_YAW)*Y_light_K )
   	                LK=math.cos( math.radians(YAW+Rotate_YAW)*Y_light_LK )
   	                if LK < 0.6:
   	                    LK = 0.6
  	 	        YAW_X=YAW_W+100*math.sin(    math.radians(  (YAW+Rotate_YAW) ) )
		        YAW_Y=YAW_H
		        
	   	        if i == 0:                 #N
	   	            YAW_Label[0]= Label(group="pitch_Line",text=str(" N "),pos=( YAW_X-50 , YAW_Y-25),halign= 'left',  text_size=[None, 0], font_size= 15,color =[LK,LK,LK,1])
	   	            Color( 1*K, 0, 0) 
	   	            YAW_Line[i] =  Line(group="yaw_Line",
		                points=[YAW_X,YAW_Y,YAW_X, YAW_Y+10],width=2)
		                
	   	        if i == 9:                 #N
	   	            YAW_Label[1]= Label(group="pitch_Line",text=str(" W "),pos=( YAW_X-50 , YAW_Y-25),halign= 'left',  text_size=[None, 0], font_size= 15,color =[LK,LK,LK,1])
	   	            Color( 1*K, 0, 0) 
	   	            YAW_Line[i] =  Line(group="yaw_Line",
		                points=[YAW_X,YAW_Y,YAW_X, YAW_Y+10],width=2)
		                
	   	        if i == 18:                 #N
	   	            YAW_Label[2]= Label(group="pitch_Line",text=str(" S "),pos=( YAW_X-50 , YAW_Y-25),halign= 'left',  text_size=[None, 0], font_size= 15,color =[LK,LK,LK,1])
	   	            Color( 1*K, 0, 0) 
	   	            YAW_Line[i] =  Line(group="yaw_Line",
		                points=[YAW_X,YAW_Y,YAW_X, YAW_Y+10],width=2)
		                
	   	        if i == 27:                 #N
	   	            YAW_Label[3]= Label(group="pitch_Line",text=str(" E "),pos=( YAW_X-50 , YAW_Y-25),halign= 'left',  text_size=[None, 0], font_size= 15,color =[LK,LK,LK,1])
	   	            Color( 1*K+0.2, 0, 0) 
	   	            YAW_Line[i] =  Line(group="yaw_Line",
		                points=[YAW_X,YAW_Y,YAW_X, YAW_Y+10],width=2)
			   
	   	        if i != 0 and i != 9 and i != 18 and i != 27 :
	   	            Color(HUD_R, HUD_G, HUD_B)
   	                    Color( HUD_R*K, HUD_G*K, HUD_B*K)
		            YAW_Line[i] =  Line(group="yaw_Line",
		                points=[YAW_X,YAW_Y,YAW_X, YAW_Y+10],width=1)
		                
		    Rotate_YAW=  Rotate_YAW+10
	    
#####################################################################################	    
	#Pitch
#####################################################################################
	P_light_K =1.4  
	P_light_LK =2
        PITCH_W =100#300
        PITCH_H =0#200
        PITCH_Circle =175
        LK=0
        LK_FLG=0
	with self.canvas.after:
            Color( 1, 1, 0)
	    Rotate_PITCH=-180
	    RAD_ROLL = math.radians( ROLL )
	    for i in xrange(0, 72):
   	            if i == 36:                 #P=0   0.71
   	                Color( 1, 0, 0)
  	 	    if math.cos( math.radians(PITCH+Rotate_PITCH) )>0.71 and  math.cos( math.radians(PITCH+Rotate_PITCH) )<0.99:
  	 	        
   	                K=math.cos( math.radians( (PITCH+Rotate_PITCH)*P_light_K )  )
   	                
   	                if K<0 and Rotate_PITCH<0: 
   	                    K=math.cos( math.radians( (PITCH+Rotate_PITCH+360)*P_light_K )  )
   	                    LK_FLG=1
   	                if K<0 and Rotate_PITCH>0: 
   	                    K=math.cos( math.radians( (PITCH+Rotate_PITCH-360)*P_light_K )  )
   	                    LK_FLG=2
   	                    
   	                if K < 0.3:
   	                     K = 0.3
   	                     
   	                #右側
   	                Color( HUD_R*K, HUD_G*K, HUD_B*K)
   	                
  	 	        PITCH_X=PITCH_W
		        PITCH_Y=PITCH_H+PITCH_Circle*math.sin(    -math.radians(PITCH+Rotate_PITCH) )
		        
		        PITCH_X_ =   PITCH_X *Roll_C + PITCH_Y *Roll_S+200
		        PITCH_Y_ = - PITCH_X *Roll_S + PITCH_Y *Roll_C+225-10
		        
  	 	        PITCH_X=PITCH_W+25
		        
		        PITCH_X_L =   PITCH_X *Roll_C + PITCH_Y *Roll_S+200-50
		        PITCH_Y_L = - PITCH_X *Roll_S + PITCH_Y *Roll_C+225-50-10
   	                LK=math.cos( math.radians(PITCH+Rotate_PITCH)*P_light_LK )      
   	                
   	                if LK_FLG==1: 
   	                    LK=math.cos( math.radians(PITCH+Rotate_PITCH+360)*P_light_LK )
   	                if LK_FLG==2: 
   	                    LK=math.cos( math.radians(PITCH+Rotate_PITCH-360)*P_light_LK )
   	                if LK < 0.3:
   	                    LK = 0.3
		        
		        
		        
		        if Rotate_PITCH%10 ==0:
   	                        
		            PITCH_Line1[i] =  Line(group="pitch_Line",
		                points=[PITCH_X_,PITCH_Y_,PITCH_X_+10*math.cos( -RAD_ROLL )  ,  PITCH_Y_+10*math.sin( -RAD_ROLL )  ],width=1.1)  
		            PITCH_Label1[i]= Label(group="pitch_Line",text=str(-Rotate_PITCH),pos=( PITCH_X_L , PITCH_Y_L),halign= 'left',  text_size=[None, 0], font_size= 15
		            ,color =[LK,LK,LK,1])
                        else :
		            PITCH_Line1[i] =  Line(group="pitch_Line",
		                points=[PITCH_X_,PITCH_Y_,PITCH_X_+7*math.cos(-RAD_ROLL )  ,  PITCH_Y_+7*math.sin( -RAD_ROLL )  ],width=1)
		                
		                
   	                #左側
   	                Color( HUD_R*K, HUD_G*K, HUD_B*K)
		                
		        PITCH_X=PITCH_W
		        PITCH_Y=PITCH_H+PITCH_Circle*math.sin(    math.radians(PITCH+Rotate_PITCH) )
		        
		        PITCH_X_ =   PITCH_X *Roll_C2 + PITCH_Y *Roll_S2+200
		        PITCH_Y_ = - PITCH_X *Roll_S2 + PITCH_Y *Roll_C2+225-10
		        
  	 	        PITCH_X=PITCH_W+15
		        
		        PITCH_X_L =   PITCH_X *Roll_C2 + PITCH_Y *Roll_S2+200-50
		        PITCH_Y_L = - PITCH_X *Roll_S2 + PITCH_Y *Roll_C2+225-50-10
   	                LK=math.cos( math.radians(PITCH+Rotate_PITCH)*P_light_LK )      
   	                
   	                if LK_FLG==1: 
   	                    LK=math.cos( math.radians(PITCH+Rotate_PITCH+360)*P_light_LK )
   	                if LK_FLG==2: 
   	                    LK=math.cos( math.radians(PITCH+Rotate_PITCH-360)*P_light_LK )
   	                if LK < 0.3:
   	                    LK = 0.3
		        
		        
		        if Rotate_PITCH%10 ==0:
   	                                
		            PITCH_Line2[i] =  Line(group="pitch_Line",
		                points=[PITCH_X_,PITCH_Y_,PITCH_X_+10*math.cos(-RAD_ROLL )  ,  PITCH_Y_+10*math.sin( -RAD_ROLL )  ],width=1.1)
                            PITCH_Label2[i]= Label(group="pitch_Line",text=str(-Rotate_PITCH),pos=( PITCH_X_L , PITCH_Y_L),halign= 'left',  
                            text_size=[None, 0], font_size= 15
		            ,color =[LK,LK,LK,1])
                        else :		                
		            PITCH_X=PITCH_W-4
		            PITCH_Y=PITCH_H+PITCH_Circle*math.sin(    math.radians(PITCH+Rotate_PITCH) )
		        
		            PITCH_X_ =   PITCH_X *Roll_C2 + PITCH_Y *Roll_S2+200
		            PITCH_Y_ = - PITCH_X *Roll_S2 + PITCH_Y *Roll_C2+225-10
		            PITCH_Line2[i] =  Line(group="pitch_Line",
		                points=[PITCH_X_,PITCH_Y_,PITCH_X_+7*math.cos(-RAD_ROLL )  ,  PITCH_Y_+7*math.sin( -RAD_ROLL )  ],width=1)
                   
               
		    Rotate_PITCH=  Rotate_PITCH+5
	    ##
	    ##0ラベル-１
	    ##	           
            PITCH_X=PITCH_W
            PITCH_Y=PITCH_H+PITCH_Circle*math.sin(    -math.radians(0) )
                
            PITCH_X_ =   PITCH_X *Roll_C + PITCH_Y *Roll_S+200
            PITCH_Y_ = - PITCH_X *Roll_S + PITCH_Y *Roll_C+225-10
                
            PITCH_X=PITCH_W+30
                
            PITCH_X_L =   PITCH_X *Roll_C + PITCH_Y *Roll_S+200-50
            PITCH_Y_L = - PITCH_X *Roll_S + PITCH_Y *Roll_C+225-50-10
            Pitch_format_='%.1f' % PITCH
            PITCH_Label1[i]= Label(group="pitch_Line",text='[b]'+str(Pitch_format_)+'[/b]',pos=( PITCH_X_L , PITCH_Y_L),halign= 'left',  text_size=[None, 0], font_size= 17,markup=True)
    
            TRI_H=10    
            TRI_W=3.5
            P1_OFF_X = 9
            PITCH_X=PITCH_W+P1_OFF_X
            PITCH_Y=PITCH_H+PITCH_Circle*math.sin(   0 )
            PITCH_X_ =   PITCH_X *Roll_C + PITCH_Y *Roll_S+200
            PITCH_Y_ = - PITCH_X *Roll_S + PITCH_Y *Roll_C+225-10 
               
            TRI_X_1 =   PITCH_X *Roll_C + PITCH_Y *Roll_S+200
            TRI_Y_1 = - PITCH_X *Roll_S + PITCH_Y *Roll_C+225-10
            TRI_X=PITCH_W-TRI_H+P1_OFF_X
            TRI_Y=PITCH_H+PITCH_Circle*math.sin(    -math.radians(0) )+TRI_W
            TRI_X_0 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
            TRI_Y_0 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
            TRI_X=PITCH_W-TRI_H+P1_OFF_X
            TRI_Y=PITCH_H+PITCH_Circle*math.sin(    -math.radians(0) )-TRI_W
            TRI_X_2 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
            TRI_Y_2 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
            Triangle(points=[TRI_X_2 ,TRI_Y_2,    TRI_X_1 ,TRI_Y_1,   TRI_X_0,TRI_Y_0])

            PITCH_W =100#300
            PITCH_H =0#200
	    Rotate_PITCH=-180
            LK_FLG=0
            
	    ##
	    ##0ラベル−２
	    ##	      
            PITCH_X=PITCH_W
            PITCH_Y=PITCH_H+PITCH_Circle*math.sin(    -math.radians(0) )
                
            PITCH_X_ =   PITCH_X *Roll_C2 + PITCH_Y *Roll_S2+200
            PITCH_Y_ = - PITCH_X *Roll_S2 + PITCH_Y *Roll_C2+225-10
                
            PITCH_X=PITCH_W+18
                
            PITCH_X_L =   PITCH_X *Roll_C2 + PITCH_Y *Roll_S2+200-50
            PITCH_Y_L = - PITCH_X *Roll_S2 + PITCH_Y *Roll_C2+225-50-10
            Pitch_format_='%.1f' % PITCH
            PITCH_Label2[i]= Label(group="pitch_Line",text='[b]'+str(Pitch_format_)+'[/b]',pos=( PITCH_X_L , PITCH_Y_L),halign= 'left',  text_size=[None, 0], font_size= 17,markup=True)
            
            PITCH_X=PITCH_W
            PITCH_Y=PITCH_H+PITCH_Circle*math.sin(   0 )
            PITCH_X_ =   PITCH_X *Roll_C2 + PITCH_Y *Roll_S2+200
            PITCH_Y_ = - PITCH_X *Roll_S2 + PITCH_Y *Roll_C2+225-10    
            TRI_X_1 =   PITCH_X *Roll_C2 + PITCH_Y *Roll_S2+200
            TRI_Y_1 = - PITCH_X *Roll_S2 + PITCH_Y *Roll_C2+225-10
            TRI_X=PITCH_W-TRI_H
            TRI_Y=PITCH_H+PITCH_Circle*math.sin(    -math.radians(0) )+TRI_W
            TRI_X_0 =   TRI_X *Roll_C2 + TRI_Y *Roll_S2+200
            TRI_Y_0 = - TRI_X *Roll_S2 + TRI_Y *Roll_C2+225-10
            TRI_X=PITCH_W-TRI_H
            TRI_Y=PITCH_H+PITCH_Circle*math.sin(    -math.radians(0) )-TRI_W
            TRI_X_2 =   TRI_X *Roll_C2 + TRI_Y *Roll_S2+200
            TRI_Y_2 = - TRI_X *Roll_S2 + TRI_Y *Roll_C2+225-10
            Triangle(points=[TRI_X_2 ,TRI_Y_2,    TRI_X_1 ,TRI_Y_1,   TRI_X_0,TRI_Y_0])
            
#####################################################################################	    
	#ROLL
#####################################################################################
	    
        ROLL_W =100#300
        ROLL_H =0#200
        ROLL_Circle =45
        ROLL_L =3
	with self.canvas.after:
           # self.canvas.remove_group("roll_Line")
            Color( HUD_R, HUD_G, HUD_B)
	    Rotate_ROLL=0
	    RAD_ROLL = math.radians( ROLL ) 
	   # Label(group="roll_Line",text='[b]'+str(ROLL_format_)+'[/b]',pos=( 200-50 ,125-50),halign= 'left',  text_size=[None, 0], font_size= 16,markup=True)
            #time.sleep(0.01)
                     
            PITCH_HEIGHT=300
            TRI_H=5
            TRI_W=4.5
            TRI_X=200 -200 
	    TRI_Y=PITCH_HEIGHT-10 -(225-10) 
            TRI_X_2 =   TRI_X *Roll_C + TRI_Y *Roll_S+200-50
            TRI_Y_2 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10-50
            TRI_X=200 -200        
	    TRI_Y=PITCH_HEIGHT -(225-10) +TRI_H
            TRI_X_1 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
            TRI_Y_1 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
         
            TRI_X=200 -200       +TRI_W 
       	    TRI_Y=PITCH_HEIGHT -(225-10) 
            TRI_X_0 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
            TRI_Y_0 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
            TRI_X=200 -200       -TRI_W 
	    TRI_Y=PITCH_HEIGHT -(225-10) 
            TRI_X_2 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
            TRI_Y_2 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
            Color( 1, 1, 1)
            Triangle(points=[TRI_X_2 ,TRI_Y_2,    TRI_X_1 ,TRI_Y_1,   TRI_X_0,TRI_Y_0])
   	    LK=math.cos( math.radians(PITCH+Rotate_PITCH)*P_light_LK )  
            Color( HUD_R, HUD_G, HUD_B)    
	    for i in xrange(0, 36):
 	        ROLL_X=ROLL_W+ROLL_Circle*math.cos(    math.radians(Rotate_ROLL) )+100
	        ROLL_Y=ROLL_H+ROLL_Circle*math.sin(    math.radians(Rotate_ROLL) )+225-10
	        ROLL_Line[i] =  Line(group="roll_Line",
	                points=[ROLL_X,ROLL_Y,ROLL_X+ROLL_L*math.cos(    math.radians(Rotate_ROLL) )  ,  ROLL_Y+ROLL_L*math.sin(    math.radians(Rotate_ROLL) )  ],width=1)
	        Rotate_ROLL=  Rotate_ROLL+10
	        
	    Rotate_ROLL=-90
            ROLL_Circle =90
            
	    for i in xrange(0, 72):
  	 	if i == 36:                 #P=0   0.71
   	            Color( 1, 0, 0)
   	        else:
                    Color( HUD_R, HUD_G, HUD_B)
   	        #    
 	        if (math.sin( math.radians(ROLL+Rotate_ROLL) ))>0.7 and  math.sin( math.radians(ROLL+Rotate_ROLL) )<0.99:
   	                K=math.sin( math.radians( (ROLL+Rotate_ROLL-25)*P_light_K )  )
   	                if K<0 and Rotate_ROLL<0: 
   	                    K=math.sin( math.radians( (ROLL+Rotate_ROLL-25+360)*P_light_K )  )
   	                    LK_FLG=1
   	                if K<0 and Rotate_ROLL>0: 
   	                    K=math.sin( math.radians( (ROLL+Rotate_ROLL-25-360)*P_light_K )  )
   	                    LK_FLG=2
   	                    
   	                LK=K
   	                if K < 0.3:
   	                     K = 0.3
   	                Color( HUD_R*K, HUD_G*K, HUD_B*K)
   	        
			ROLL_X=PITCH_W
			ROLL_X=PITCH_H
			
		        ROLL_X=ROLL_W+ROLL_Circle*math.cos(    math.radians(Rotate_ROLL) )+100
			ROLL_Y=ROLL_H+ROLL_Circle*math.sin(    math.radians(Rotate_ROLL) )+225-10
   	                
			
			if Rotate_ROLL%10 ==0:
                                ROLL_L =15
				ROLL_Line[i] =  Line(group="roll_Line",
					points=[ROLL_X,ROLL_Y,ROLL_X+ROLL_L*math.cos(    math.radians(Rotate_ROLL) )  ,
					  ROLL_Y+ROLL_L*math.sin(    math.radians(Rotate_ROLL) )  ],width=1)
				
				ROLL_X=PITCH_W
				ROLL_X=PITCH_H
	 		        ROLL_Circle_L =115
            
				
				ROLL_X_L =   ROLL_W+ROLL_Circle_L*math.cos(    math.radians(Rotate_ROLL) ) + 100-50
				ROLL_Y_L =   ROLL_H+ROLL_Circle_L*math.sin(    math.radians(Rotate_ROLL) )+225-50-10
				ROLL_Label[i]= Label(group="roll_Line",text=str(Rotate_ROLL-90),pos=( ROLL_X_L , ROLL_Y_L),halign= 'left',  text_size=[None, 0], font_size= 13
		                ,color =[LK,LK,LK,1])
            
			else:
                                ROLL_L =7.5
				ROLL_Line[i] =  Line(group="roll_Line",
					points=[ROLL_X,ROLL_Y,ROLL_X+ROLL_L*math.cos(    math.radians(Rotate_ROLL) )  ,  ROLL_Y+ROLL_L*math.sin(    math.radians(Rotate_ROLL) )  ],width=1)
	   
	        Rotate_ROLL=  Rotate_ROLL+5
            ROLL_L =28
	    ROLL_X=ROLL_W+ROLL_Circle*math.cos(    math.radians( -ROLL+90 ) )+100
            ROLL_Y=ROLL_H+ROLL_Circle*math.sin(   math.radians( -ROLL+90 ) )+225-10
			
	    ROLL_Line_ =  Line(group="roll_Line",
			points=[ROLL_X,ROLL_Y,ROLL_X+ROLL_L*math.cos(    math.radians( -ROLL+90 ))  ,
			  ROLL_Y+ROLL_L*math.sin(math.radians( -ROLL+90 ))  ],width=1)
	    ROLL_Circle_L =125

	    ROLL_format_='%.1f' % -ROLL
	    ROLL_X_L =   ROLL_W+ROLL_Circle_L*math.cos(    math.radians( -ROLL+90 ) ) + 100-50
	    ROLL_Y_L =   ROLL_H+ROLL_Circle_L*math.sin(    math.radians( -ROLL+90 ) )+225-50-10
	    ROLL_Label[i]= Label(group="roll_Line",text='[b]'+str(ROLL_format_)+'[/b]',pos=( ROLL_X_L , ROLL_Y_L),halign= 'left',  text_size=[None, 0], font_size= 15,markup=True)
            
#####################################################################################	    
	#Center　Line? 
#####################################################################################

	with self.canvas.after:
		 ##
		 ##ROLL
		 ##               
                 Color( HUD_R, HUD_G, HUD_B)
	         Line(group="Central_Line",
		                points=[ 200 , 245 , 200  ,  248  ],width=1)
	         Line(group="Central_Line",
		                points=[ 200 , 185 , 200  ,  182  ],width=1)
		                
	         Line(group="Central_Line",
		                points=[ 167 , 215 , 170 ,  215  ],width=1)
	         Line(group="Central_Line",
		                points=[ 230 , 215 , 233  ,  215  ],width=1)
		                
		                
		 ##
		 ## 回る中央線
		 ## 
		 
		 PITCH_PLUS =  25*math.sin(math.radians( PITCH ) )
		 
		 ROLL_CS_LINE_X=180 -200
		 ROLL_CS_LINE_Y=215 -(225-10) + PITCH_PLUS
		 ROLL_CS_LINE_X_ =   ROLL_CS_LINE_X *Roll_C + ROLL_CS_LINE_Y *Roll_S+200
		 ROLL_CS_LINE_Y_ = - ROLL_CS_LINE_X *Roll_S + ROLL_CS_LINE_Y *Roll_C+225-10
		 ROLL_CE_LINE_X=220  -200
		 ROLL_CE_LINE_Y=215      -(225-10)  + PITCH_PLUS      
		 ROLL_CE_LINE_X_ =   ROLL_CE_LINE_X *Roll_C + ROLL_CE_LINE_Y *Roll_S+200
		 ROLL_CE_LINE_Y_ = - ROLL_CE_LINE_X *Roll_S + ROLL_CE_LINE_Y *Roll_C+225-10
	         Line(group="Central_Line",
		                points=[  ROLL_CS_LINE_X_ ,  ROLL_CS_LINE_Y_ ,  ROLL_CE_LINE_X_  ,   ROLL_CE_LINE_Y_  ],width=1)
		                
		                
		                
		 ROLL_CS_LINE_X=130 -200
		 ROLL_CS_LINE_Y=215 -(225-10) 
		 ROLL_CS_LINE_X_ =   ROLL_CS_LINE_X *Roll_C + ROLL_CS_LINE_Y *Roll_S+200
		 ROLL_CS_LINE_Y_ = - ROLL_CS_LINE_X *Roll_S + ROLL_CS_LINE_Y *Roll_C+225-10
		 ROLL_CE_LINE_X=160  -200
		 ROLL_CE_LINE_Y=215      -(225-10)        
		 ROLL_CE_LINE_X_ =   ROLL_CE_LINE_X *Roll_C + ROLL_CE_LINE_Y *Roll_S+200
		 ROLL_CE_LINE_Y_ = - ROLL_CE_LINE_X *Roll_S + ROLL_CE_LINE_Y *Roll_C+225-10
	         Line(group="Central_Line",
		                points=[  ROLL_CS_LINE_X_ ,  ROLL_CS_LINE_Y_ ,  ROLL_CE_LINE_X_  ,   ROLL_CE_LINE_Y_  ],width=1)
		 ROLL_CS_LINE_X=240 -200
		 ROLL_CS_LINE_Y=215 -(225-10) 
		 ROLL_CS_LINE_X_ =   ROLL_CS_LINE_X *Roll_C + ROLL_CS_LINE_Y *Roll_S+200
		 ROLL_CS_LINE_Y_ = - ROLL_CS_LINE_X *Roll_S + ROLL_CS_LINE_Y *Roll_C+225-10
		 ROLL_CE_LINE_X=270  -200
		 ROLL_CE_LINE_Y=215      -(225-10)        
		 ROLL_CE_LINE_X_ =   ROLL_CE_LINE_X *Roll_C + ROLL_CE_LINE_Y *Roll_S+200
		 ROLL_CE_LINE_Y_ = - ROLL_CE_LINE_X *Roll_S + ROLL_CE_LINE_Y *Roll_C+225-10
	         Line(group="Central_Line",
		                points=[  ROLL_CS_LINE_X_ ,  ROLL_CS_LINE_Y_ ,  ROLL_CE_LINE_X_  ,   ROLL_CE_LINE_Y_  ],width=1)
		                
                 Pitch_MEM= -25
	         for i in xrange(0, 11):
			 ROLL_CS_LINE_X=199 -200
			 if i==0 or i == 5 or i == 10: 
				 ROLL_CS_LINE_X=197 -200
				 
			 ROLL_CS_LINE_Y=215 -(225-10) +Pitch_MEM
			 ROLL_CS_LINE_X_ =   ROLL_CS_LINE_X *Roll_C + ROLL_CS_LINE_Y *Roll_S+200
			 ROLL_CS_LINE_Y_ = - ROLL_CS_LINE_X *Roll_S + ROLL_CS_LINE_Y *Roll_C+225-10
			 
			 ROLL_CE_LINE_X=201  -200
			 
			 if i==0 or i == 5 or i == 10: 
				 ROLL_CE_LINE_X=203  -200
				 
			 ROLL_CE_LINE_Y=215      -(225-10)        +Pitch_MEM
			 ROLL_CE_LINE_X_ =   ROLL_CE_LINE_X *Roll_C + ROLL_CE_LINE_Y *Roll_S+200
			 ROLL_CE_LINE_Y_ = - ROLL_CE_LINE_X *Roll_S + ROLL_CE_LINE_Y *Roll_C+225-10
			 Line(group="Central_Line",
				        points=[  ROLL_CS_LINE_X_ ,  ROLL_CS_LINE_Y_ ,  ROLL_CE_LINE_X_  ,   ROLL_CE_LINE_Y_  ],width=1)
	                 Pitch_MEM =Pitch_MEM +5
	                 
		 ##
		 ## 回る中央△
		 ##              
                 Color( HUD_R, HUD_G, HUD_B)
                 TRI_H=5
                 TRI_W=4.5
                 PITCH_HEIGHT=390
                 TRI_X=200 -200        
		 TRI_Y=215 -(225-10) +TRI_H + PITCH_PLUS
                 TRI_X_1 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
                 TRI_Y_1 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
                 
                 TRI_X=200 -200       +TRI_W 
		 TRI_Y=215 -(225-10) + PITCH_PLUS
                 TRI_X_0 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
                 TRI_Y_0 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
                 TRI_X=200 -200       -TRI_W 
		 TRI_Y=215 -(225-10) + PITCH_PLUS
                 TRI_X_2 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
                 TRI_Y_2 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
                 Triangle(points=[TRI_X_2 ,TRI_Y_2,    TRI_X_1 ,TRI_Y_1,   TRI_X_0,TRI_Y_0])
            
		 ##
		 ## 回るPITCH△
		 ##    
                 if PITCH >=0:
                     PITCH_HEIGHT=365
                     TRI_H=5.5
                     TRI_W=20
                     TRI_X=200 -200 
   		     TRI_Y=PITCH_HEIGHT-10 -(225-10) 
                     TRI_X_2 =   TRI_X *Roll_C + TRI_Y *Roll_S+200-50
                     TRI_Y_2 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10-50
                 if PITCH <0:
                     PITCH_HEIGHT=125
                     TRI_H=-5.5
                     TRI_W=20
                 TRI_X=200 -200        
		 TRI_Y=PITCH_HEIGHT -(225-10) +TRI_H
                 TRI_X_1 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
                 TRI_Y_1 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
                 
                 TRI_X=200 -200       +TRI_W 
		 TRI_Y=PITCH_HEIGHT -(225-10) 
                 TRI_X_0 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
                 TRI_Y_0 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
                 TRI_X=200 -200       -TRI_W 
		 TRI_Y=PITCH_HEIGHT -(225-10) 
                 TRI_X_2 =   TRI_X *Roll_C + TRI_Y *Roll_S+200
                 TRI_Y_2 = - TRI_X *Roll_S + TRI_Y *Roll_C+225-10
                 Triangle(points=[TRI_X_2 ,TRI_Y_2,    TRI_X_1 ,TRI_Y_1,   TRI_X_0,TRI_Y_0])
		         
		 ##
		 ## 回ranai中央△
		 ##           
                 Color( 1, 1, 1)
                 TRI_H=5
                 TRI_W=4.5
                 YAW_HEIGHT=390
                 TRI_X=200       
		 TRI_Y=YAW_HEIGHT  +TRI_H
                 TRI_X_0 =TRI_X
                 TRI_Y_0 =TRI_Y 
                 
                 TRI_X=200        +TRI_W 
		 TRI_Y=YAW_HEIGHT 
                 TRI_X_1 =TRI_X
                 TRI_Y_1 =TRI_Y 
                 TRI_X=200        -TRI_W 
		 TRI_Y=YAW_HEIGHT  
                 TRI_X_2 =TRI_X
                 TRI_Y_2 =TRI_Y 
                 Triangle(points=[TRI_X_2 ,TRI_Y_2,    TRI_X_1 ,TRI_Y_1,   TRI_X_0,TRI_Y_0])


      #  time.sleep(0.01)
        pass
        
    def send_Pose(self,data_):
        global ROLL,PITCH,YAW
	
	ROLL=-data_[3]
	PITCH=data_[4]
	YAW=data_[5]
	
        return data_
        
        
    def Conf_popup(self):
        global btn1,btn2
        
        btn_C = Button(text="Close",pos=(.10, .30),size_hint=(1, .3))
        ##############################################################################
        lab1 = Label(text="                          Deg                  Rad",
        font_size=12)
        lab2 = Label(text="InPort")
        btn1 = CheckBox(group='orientation',active = self.Con_Port_In_deg)
        btn2 = CheckBox(group='orientation',active = self.Con_Port_In_rad)
        ##############################################################################
        
        
        Contens = BoxLayout(
        orientation= "vertical",  spacing =10)
        
        Contens_1_lab = BoxLayout(
        orientation= "horizontal"
        )
        Contens_1 = BoxLayout(
        orientation= "horizontal"
        )
        Contens_1_lab.add_widget(lab1)
        Contens.add_widget(Contens_1_lab)
        
        Contens_1.add_widget(lab2)
        Contens_1.add_widget(btn1)
        Contens_1.add_widget(btn2)
        Contens.add_widget(Contens_1)
        
        pop_up = Popup(title="RPY_Viewer Config",size_hint=(.70, .25),content=Contens)
        
        btn_C.bind(on_press = pop_up.dismiss )
        Clock.schedule_interval(self.conf_loop, 1/10.)
        
        pop_up.open()
        pass
        
    def conf_loop(self,dt):
        global btn1,btn2
        
        self.Con_Port_In_deg =  btn1.active
        self.Con_Port_In_rad  = btn2.active
        if  self.Con_Port_In_deg == False and self.Con_Port_In_rad  == False :
        	self.Con_Port_In_rad  = True
        	
class rpy_viewerApp(App):
    def build(self):
        Window.size = (400,500)
        return RootWidget()
        
        
if  __name__ == '__main__':rpy_viewerApp().run()
